const { Component } = wp.element;
import Filter from './Filter';
import axios from 'axios';

class Main extends Component {
    state = {
        mainData: '',
        isLoaded: false,
        mainFilterID: 0
    }

    async componentDidMount() {
        const atts = this.props.shortcodeSettings;
        let id = 0;
        if( atts ){
            id = (typeof(atts.id) != "undefined" && atts.id !== null) ? atts.id : 0;
            let filterUrl = `${main_site_url.url}/wp-json/wp/v2/ff_filter/${id}`;
            if( permalink_structure.val == '' ){
                filterUrl = `${main_site_url.url}/?rest_route=/wp/v2/ff_filter/${id}`;
            }
            axios.get(filterUrl).then( res => {
                const setting = (typeof(res.data.meta.fff_settings) != "undefined" && res.data.meta.fff_settings !== null) ? JSON.parse(res.data.meta.fff_settings) : 0;
            
                this.setState({
                    mainData: setting,
                    isLoaded: true,
                    mainFilterID: id
                });
            } )
            .catch( error => {
                if( axios.isCancel(error) || error ){
                    this.setState({
                        message: `${error}`
                    })
                }
            } );
        }
    }

    render() {
        const { mainData, mainFilterID, isLoaded, message } = this.state;
        if(isLoaded && mainData){
          return(
                <div className="fff-main-content">
                    <Filter filterid={mainFilterID} data={mainData} />
                </div>
            )
        }

        return(
            <p>{message}</p>
        )
    }
}

export default Main;