const { Component } = wp.element;

class RadioType extends Component {
    render() {
        const { __ } = wp.i18n;
        const { mainfilter, filter, option, handleRadio, name, query } = this.props;
        if ( Object.keys(filter).length && filter.length ) {
            const defaultCheck = ( query.length == 0 ) ? 'true' : '';
            return(
                <div className="fff-sidebar-cont fff-nav-radio-cont">
                    {name != '' && <p className="fff-sidebar-title">{name}</p>}
                    <div className="fff-nav-radio">
                        <input id={`fff-check-all-${mainfilter}`} type="radio" name={option} value="" onChange={handleRadio} checked={defaultCheck} defaultChecked />
                        <label for={`fff-check-all-${mainfilter}`}>{__( 'All results', 'fffilter' )}</label>
                    </div>
                    {filter.map(result => {
                        const checkVal = ( result.id.toString() == query ) ? 'true' : '';
                        const parent = ( result.parent !== undefined ) ? result.parent : 0;
                        if( parent == 0 ){
                            return (
                                <div className="fff-nav-radio">
                                    <input id={`fff-check-${result.id}-${mainfilter}`} type="radio" name={option} value={result.id} onChange={handleRadio} checked={checkVal} />
                                    <label for={`fff-check-${result.id}-${mainfilter}`}>{result.name}</label>
                                </div>
                            );
                        }
                    } ) }
                </div>
            )
        }

        return null;
    }
}

export default RadioType;