const { Component } = wp.element;

class SelectType extends Component {
    render() {
        const { filter, option, handleSelect, name, query } = this.props;
        if ( Object.keys(filter).length && filter.length ) {
            return(
                <div className="fff-sidebar-cont fff-nav-select-cont">
                    {name != '' && <p className="fff-sidebar-title">{name}</p>}
                    <div className="fff-nav-select">
                        <select name={option} onChange={handleSelect}>
                            <option value="">--select--</option>
                            {filter.map(result => {
                                const checkVal = ( result.id.toString() == query ) ? 'true' : '';
                                const parent = ( result.parent !== undefined ) ? result.parent : 0;
                                if( parent == 0 ){
                                    return (
                                        <option value={result.id} selected={checkVal}>{result.name}</option>
                                    );
                                }
                            } ) }
                        </select>
                    </div>
                </div>
            )
        }

        return null;
    }
}

export default SelectType;