jQuery( document ).ready(function($) {

    $('body').on('click', '.ff-filters-option-input input', function(){
        $(this).addClass('active');
    });

    $('input.fff-color-field').wpColorPicker();

    if( $('.fff-code-field').length ) {
        var editorSettings = wp.codeEditor.defaultSettings ? _.clone( wp.codeEditor.defaultSettings ) : {};
        editorSettings.codemirror = _.extend(
            {},
            editorSettings.codemirror,
            {
                indentUnit: 2,
                tabSize: 2,
                mode: 'css',
            }
        );
        var editor = wp.codeEditor.initialize( $('.fff-code-field'), editorSettings );
    }

    $(document).on('click', function (event) {
        if (!$(event.target).closest('.ff-filters-option-input').length) {
            $('body').find('.ff-filters-option-input input').each(function(){
                if( $(this).val() == '' ){
                    $(this).removeClass('active');
                }
            });
        }
    });

    var fffSettingsFrom = {
        init: function () {
            this.settingsForm.init();
        },

        settingsForm: {
            $form: null,
            $generalForm: null,

            init: function () {
                this.$form = $('.fff-new-filter-form');
                this.$generalForm = $('.fff-general-filter-form');
                this.addEventListeners();
            },

            addEventListeners: function () {
                var _this = this;

                _this.$form.on('submit', function (event) {
                    event.preventDefault();
                    _this.sign($(this));
                    return false;
                });

                _this.$generalForm.on('submit', function (event) {
                    event.preventDefault();
                    _this.signG($(this));
                    return false;
                });
            },

            sign: function ($form) {
                var _this = this;
                var data = $form.serializeArray();
                var postData = new FormData();
                $.each(data, function(i, val) {
                    postData.append(val.name, val.value);
                });
                postData.append('action', 'fff_save_settins');
                $.ajax({  
                    type: "POST",
                    data: postData,
                    url: fff_ajax_url.url,
                    cache: false,
                    contentType: false,
                    processData: false,
                    success: function(result) {
                        var obj = JSON.parse(result);
                        if(typeof(obj.id) != "undefined" && obj.id !== null) {
                            var filterId = obj.id;
                            $('.fff-popup-save-filer').addClass('active');
                            $('.fff-popup-save-filer .fff-edit').attr('href', fff_admin_page_url.url + '&edit=' + filterId);
                        }
                    }
                });
            },

            signG: function ($form) {
                var _this = this;
                var data = $form.serializeArray();
                var postData = new FormData();
                $.each(data, function(i, val) {
                    postData.append(val.name, val.value);
                });
                postData.append('action', 'fff_save_settins');
                $.ajax({  
                    type: "POST",
                    data: postData,
                    url: fff_ajax_url.url,
                    cache: false,
                    contentType: false,
                    processData: false,
                    success: function(result) {
                        var obj = JSON.parse(result);
                        if(typeof(obj.id) != "undefined" && obj.id !== null) {
                            $('.fff-saved-popup-cont').addClass('active');
                        }
                    }
                });
            }
        }
    }

    var fffTabls = {
        init: function () {
            this.settingsTabs.init();
        },

        settingsTabs: {
            $tabs: null,
            $tabsCont: null,

            init: function () {
                this.$tabs = $('.ff-filters-nav ul li');
                this.$tabsCont = $('.ff-filter-settings .ff-filter-tab');
                this.addEventListeners();
            },

            addEventListeners: function () {
                var _this = this;

                _this.$tabs.on('click', function(){
                    var tabid = $(this).attr('data-tab');
                    _this.$tabs.removeClass('active');
                    _this.$tabsCont.removeClass('active');
                    $(this).addClass('active');
                    $('#' + tabid).addClass('active');
                    return false;
                });
            }
        }
    }

    var fffRepeater = {
        init: function () {
            this.settingsRepeater.init();
        },

        settingsRepeater: {
            $addButton: null,
            $optionsWrap: null,

            init: function () {
                this.$addButton = $('.fff-add-rep');
                this.$optionsWrap = $('.ff-filters-option');
                this.addEventListeners();
            },

            addEventListeners: function () {
                var _this = this;

                _this.$addButton.on('click', function(){
                    var content = $(this).closest('.ff-filters-option').find('.ff-filters-option-repeater-set').html();
                    var counter = $(this).closest('.ff-filters-option').find('.ff-filters-option-repeater-set').length;
                    $(this).before('<div class="ff-filters-option-repeater-set rep-item'+counter+'">'+content+'</div>');
                    if( $(this).closest('.ff-filters-option').find('.rep-item'+counter+ ' .ff-filters-option-del').length == 0 ){
                        $(this).closest('.ff-filters-option').find('.rep-item'+counter).prepend(`
                        <div class="ff-filters-option-del">
                            <img src="${fff_plugin_url.url}/assets/img/delete.svg" />
                        </div>
                        `);
                    }
                    $(this).closest('.ff-filters-option').find('.rep-item'+counter).find('.repeater-field').each(function(){
                        var defaultVal = $(this).attr('data-default');
                        if( defaultVal !== undefined ){
                            $(this).val( defaultVal ).trigger('change');
                        } else {
                            $(this).val( '' );
                        }
                    });

                    return false;
                });

                _this.$optionsWrap.on('click', '.ff-filters-option-del', function(){
                    $(this).closest('.ff-filters-option-repeater-set').remove();
                    return false;
                });
            }
        }
    }

    var fffRemoveFilter = {
        init: function () {
            this.settingsRemove.init();
        },

        settingsRemove: {
            $removeButton: null,

            init: function () {
                this.$removeButton = $('.fff-remove-filter');
                this.addEventListeners();
            },

            addEventListeners: function () {
                var _this = this;

                _this.$removeButton.on('click', function(){
                    _this.removeAct($(this).closest('tr'));
                    return false;
                });
            },

            removeAct: function ($tr) {
                var filterID = $tr.attr('data-id');
                if( filterID !== undefined ){
                    this.removePopup($tr, filterID);
                }
            },

            removePopup: function ($tr, filterID){
                $('.fff-popup-delete-filer').addClass('active');
                $('.fff-popup-delete-filer .fff-close-popup').on('click', function(){
                    $('.fff-popup-delete-filer').removeClass('active');
                    return false;
                });
                $('.fff-popup-delete-filer .fff-delete-filter').on('click', function(){
                    $('.fff-popup-delete-filer').removeClass('active');
                    $.ajax({
                        type: "POST",
                        data: {'action': 'fff_remove_filter', 'filter': filterID},
                        url: fff_ajax_url.url,
                        success: function(result) {
                            if(result != 0){
                                if( $('.ff-filters-all-table tbody tr').length > 1 ){
                                    $tr.remove();
                                } else {
                                    $tr.closest('.ff-filters-all-table').remove();
                                }
                            }
                        }
                    });
                    return false;
                });
            }
        }
    }

    fffSettingsFrom.init();
    fffTabls.init();
    fffRepeater.init();
    fffRemoveFilter.init();

    // Condition logic
    $('.ff-filter-settings').on('change', '.ff-filters-option select', function(e){  
        e.preventDefault();

        let v = $(this).val();
        let n = $(this).attr('name');

        $(this).closest('.ff-filters-option-repeater-set').find('.ff-filters-option[data-fffcond]').each(function(){
            var cond = $(this).attr('data-fffcond');

            var cond_arr = cond.split(";");
            for (i = 0; i < cond_arr.length; ++i) {
                var arrEl = cond_arr[i];
                var valV = arrEl.split("|")[1];
                var valName = arrEl.split("|")[0];
                if( valV !== undefined ){
                    var cond_arr_v = valV.split(",");
                    if( n == valName ){
                        $(this).addClass('fff-option-hide');
                        if( cond_arr_v.length == 1 && cond_arr_v[0].indexOf("!=") >= 0 ){
                            const not_val = cond_arr_v[0].replace("!=", "");
                            if( v != not_val ){
                                $(this).removeClass('fff-option-hide');
                            }
                        } else {
                            if($.inArray( v , cond_arr_v ) !== -1){
                                $(this).removeClass('fff-option-hide');
                            }
                        }
                    }
                }
            }
        });
    });

    // Change post type
    var fffPostSelVal = $('.ff-filter-settings select[name="post_types"]').val();
    var fffNewVal;
    $('.ff-filter-settings select[name="post_types"]').on('change', function(){
        fffNewVal = $(this).val();
        if( $('.fff-new-filter-form input[name="fff_save_filter_settings"]').val() != '' ){
            $('.fff-popup-post-filer').addClass('active');
            $(this).val(fffPostSelVal);
            return;
        } else {
            fffPostSelVal = fffNewVal;
            $(this).val(fffPostSelVal);
            $(this).next('.fff-error').remove();
            $.ajax({
                type: "POST",
                data: {'action': 'fff_get_taxonomies', 'post_type': fffNewVal},
                url: fff_ajax_url.url,
                success: function(result) {
                    if( result == 'norest' ){
                        $('.ff-filter-settings select[name="post_types"]').after('<p class="fff-error">Please change <a href="https://developer.wordpress.org/rest-api/extending-the-rest-api/adding-rest-api-support-for-custom-content-types/" target="_blank">show_in_rest</a> parameter to true.</p>')
                    }
                    $('.ff-filter-settings #filters .ff-filters-option .ff-filters-option-repeater-set:not(.f-set)').remove();
                    $('.ff-filter-settings #filters .ff-filters-option .f-set select[name="filters[filter_options][]"]').html(result);              
                    $('.ff-filter-settings #filters .ff-filters-option .f-set select[name="filters[filter_options][]"]').val('search').trigger('change');              
                }
            });
            return;
        }
    });

    $('.fff-popup-post-filer .fff-close-popup').on('click', function(){
        $('.fff-popup-post-filer').removeClass('active');
        return false;
    });

    $('.fff-popup-post-filer .fff-change-post-filter').on('click', function(){
        $('.fff-popup-post-filer').removeClass('active');
        $('.ff-filter-settings select[name="post_types"]').next('.fff-error').remove();
        $('.ff-filter-settings select[name="post_types"]').val(fffNewVal);
        fffPostSelVal = fffNewVal;

        // Ajax for new taxonomies
        $.ajax({
            type: "POST",
            data: {'action': 'fff_get_taxonomies', 'post_type': fffNewVal},
            url: fff_ajax_url.url,
            success: function(result) {
                if( result == 'norest' ){
                    $('.ff-filter-settings select[name="post_types"]').after('<p class="fff-error">Please change <a href="https://developer.wordpress.org/rest-api/extending-the-rest-api/adding-rest-api-support-for-custom-content-types/" target="_blank">show_in_rest</a> parameter to true.</p>')
                }
                $('.ff-filter-settings #filters .ff-filters-option .ff-filters-option-repeater-set:not(.f-set)').remove();
                $('.ff-filter-settings #filters .ff-filters-option .f-set select[name="filters[filter_options][]"]').html(result);              
                $('.ff-filter-settings #filters .ff-filters-option .f-set select[name="filters[filter_options][]"]').val('search').trigger('change');
            }
        });

        return false;
    });
});